Index: trunk/Nebulous/bin/neb-repair
===================================================================
--- trunk/Nebulous/bin/neb-repair	(revision 32529)
+++ trunk/Nebulous/bin/neb-repair	(revision 32547)
@@ -73,8 +73,15 @@
 	open($fh,$files[$i]);
 	$md5sums[$i] = Digest::MD5->new->addfile($fh)->hexdigest;
+	close($fh);
+
 	$md5sum_uniq{$md5sums[$i]} = 1;
+
+	if ($md5sums[$i] eq 'd41d8cd98f00b204e9800998ecf8427e') {
+	    $existance[$i] = 0;
+	    next;
+	}
+
 	push @{ $md5sum_valid{$md5sums[$i]} }, $files[$i];
 	$last_f = $files[$i];
-	close($fh);
     }
     else {
@@ -119,4 +126,14 @@
 		    system("cp $valid_file $f");
 		    if ($? >> 8 != 0) {
+			if ($existance[0] == 1) {
+			    # We can fix this with culls and replications.
+			    print("neb-replicate $key\n");
+			    system("neb-replicate $key");
+			    if ($? >> 8 == 0) {
+				my $bad_volume = (split /\//, $f)[2];
+				print("neb-cull --volume $bad_volume $key\n");
+				system("neb-cull --volume $bad_volume $key");
+			    }
+			}
 			die "Failed to copy file $valid_file to $f!\n";
 		    }
